#include <stdio.h>
#include <dos.h>

typedef unsigned char far *vector_t;

int main(void) {
	const char *img_name = "ivt.bin";
#define	IVT_LEN	512
	unsigned char ivt_buf[IVT_LEN];
	vector_t *boot, far *dos;
	unsigned i;
	FILE *f;

/* open and load the memory image file made by DUMP-IVT.ASM bootsector */
	if((f = fopen(img_name, "rb")) == NULL)	{
		printf("Error: can't open input file '%s'\n", img_name);
		return 2; }
	i = fread(ivt_buf, 1, IVT_LEN, f);
	fclose(f);
	if(i < IVT_LEN)	{
		printf("Error: wanted %u bytes from file %s, "
			"got only %u\n", IVT_LEN, img_name, i);
		return 3; }
/* dump interrupt vector tables (IVTs) */
	printf(	"vect before DOS loaded            after DOS loaded\n"
		"---- ---------------------------  ---------------------------\n");
	boot = (vector_t *)ivt_buf;
	dos = (vector_t far *)MK_FP(0, 0);
	for(i = 0; i < IVT_LEN / 4; i++) {
		printf("  %02X ", i);

		if(FP_OFF(boot[i]) == 0 && FP_SEG(boot[i]) == 0)
			printf("zero                ");
/* vector points to ROM BIOS (video or motherboard) */
		else if(FP_SEG(boot[i]) >= 0xC000)
			printf("unhooked-> %04X:%04X",
				FP_SEG(boot[i]), FP_OFF(boot[i]));
		else
			printf("  HOOKED-> %04X:%04X",
				FP_SEG(boot[i]), FP_OFF(boot[i]));
		if(*(dos[i]) == 0xCF)
			printf(" ->IRET  ");
		else
			printf("         ");

		if(FP_OFF(dos[i]) == 0 && FP_SEG(dos[i]) == 0)
			printf("zero");
/* vector points to ROM BIOS (video or motherboard) */
		else if(FP_SEG(dos[i]) >= 0xC000)
			printf("unhooked-> %04X:%04X",
				FP_SEG(dos[i]), FP_OFF(dos[i]));
		else
			printf("  HOOKED-> %04X:%04X",
				FP_SEG(dos[i]), FP_OFF(dos[i]));
		if(*(dos[i]) == 0xCF)
			printf(" ->IRET\n");
		else
			printf("\n"); }
	return 0; }
